/*
  Name: Leds
  Copyright: -
  Author: Skalski Lukasz
  Description: ver. 1.00
*/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

#define LED2 "/sys/class/leds/led2/brightness" 
#define LED3 "/sys/class/leds/led3/brightness" 
#define test "/sys/class/leds/test/brightness" 

int main(int argc, char *argv[]) { 

	int fd_led2, fd_led3, fd_test; 
	int param; 
	char data_1 = 0;
	char data_2 = 1;

	if ((argc == 2) && (sscanf(argv[1], "%d", &param) == 1) && (param >= 10000) && (param <= 1000000)){

		if((fd_led2 = open(LED2, O_RDWR)) < 0){
			printf("Error in open %s",LED2);
			return -1; 
		}

		if((fd_led3 = open(LED3, O_RDWR)) < 0){ 
			printf("Error in open %s",LED3);
			return -1;
		} 

		if((fd_test = open(test, O_RDWR)) < 0){
			printf("Error in open %s",test); 
			return -1; 
		} 

		for(;;){ 

			data_1 = '0';
			data_2 = '1';

			write(fd_led2, &data_1, sizeof(data_1));
 			write(fd_led3, &data_2, sizeof(data_2));
 			write(fd_test, &data_1, sizeof(data_1));

 			usleep(param); 

			data_1 = '1';
			data_2 = '0';

			write(fd_led2, &data_1, sizeof(data_1));
 			write(fd_led3, &data_2, sizeof(data_2));
 			write(fd_test, &data_1, sizeof(data_1));

 			usleep(param); 
		} 
	}else{
		fprintf(stderr, "Usage: leds delay[us]\n");
		return -1;
	}
}


