/*
  Name: ADC
  Copyright: -
  Author: Skalski Lukasz
  Description: ver. 1.00
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/i2c-dev.h>
#include <linux/i2c.h>

#define PCF8591_ADRESS 0x48

int i2c;
char buf[2];
char mode,val;

void check_ADC();
void set_DAC(char DAC_value);

int main(int argc, char *argv[]){

	if (argc != 3) {
		fprintf(stderr, "Usage: %s <Mode> <DAC_value>\n",argv[0]);
		exit(1);
	}

	i2c = open("/dev/i2c-3",O_RDWR);
	if (i2c < 0) {
		fprintf(stderr, "I2C file error!\n");
		exit(1);
	}

	if (ioctl(i2c, I2C_SLAVE, PCF8591_ADRESS) < 0) {
		fprintf(stderr, "I2C adress error!\n");
		exit(1);
	}

	mode = atoi(argv[1]);

	if (mode){
		check_ADC();
	}else{
		val = atoi(argv[2]);
		set_DAC(val);
	}
	
	close(i2c);
	return 0;
}

/* ------------------------------------------------------------------------------- */
void set_DAC (char DAC_value){

	buf[0] = 0x40;		
	buf[1] = DAC_value;		
	write(i2c, buf, 2);
	printf ("DAC: %0.2f [V] - 0x%02X HEX\n",((float)DAC_value/255)*5, DAC_value);
}

/* ------------------------------------------------------------------------------- */
void check_ADC (){

	buf[0] = 0x44;				
	write(i2c, buf, 1);
	read(i2c, buf, 1);

	read(i2c, buf, 1);
	printf ("ADC_1: %0.2f [V] - 0x%02X HEX\n",((float)buf[0]/255)*5, buf[0]);

	read(i2c, buf, 1);
	printf ("ADC_2: %0.2f [V] - 0x%02X HEX\n",((float)buf[0]/255)*5, buf[0]);

	read(i2c, buf, 1);
	printf ("ADC_3: %0.2f [V] - 0x%02X HEX\n",((float)buf[0]/255)*5, buf[0]);

	read(i2c, buf, 1);
	printf ("ADC_4: %0.2f [V] - 0x%02X HEX\n",((float)buf[0]/255)*5, buf[0]);
}

